program fit_area_odr_implicit

      use real_precision
      use odrpack95
      
! fit straight line through data from file
        
        implicit none
        character*256 ::  my_file!, arg
        real(kind=r8), dimension (:,:), allocatable ::   x,y 
        real(kind=r8), dimension (:,:), allocatable ::   ux, uy 
        real(kind=r8), dimension (:), allocatable ::   rho
        integer ::     iargc,n

        integer ::  i,  len, iostatus

        integer, parameter :: np = 5
        integer :: m, nq

        real(kind=r8) :: beta(np)
        real(kind=r8) :: stdev_beta(np)
        real(kind=r8) :: cov(np*(np-1)/2)

        real(kind=r8) :: tmp

        integer :: info


        m = 2
        nq = 1

        if (iargc().lt.1)  stop './fit_area_odr filename'
        call getarg(1,my_file)

        len = index(my_file,' ') - 1

        open(unit=77, file=my_file(1:len), status='old')
        n = 0
        read(77, *, IOSTAT=iostatus) my_file
        do  while (iostatus == 0)
          n= n+1
          read(77, *, IOSTAT=iostatus) my_file
        end do

        if (n == 0 ) then
           stop 'Empty file'
        end if 
        

        allocate(x(n, m))
        allocate(y(n, nq))
        allocate(ux(n,m))
        allocate(uy(n, nq))
        allocate(rho(n))

        write(*,*) n, m, nq, size(x)

        rewind(unit = 77)
        do i = 1,n
            read(77, *) x(i,1), x(i,2), ux(i,1), ux(i,2), tmp, rho(i)
            x(i,2) = x(i,2)*1e6 !change units to nm
            ux(i,2) = ux(i,2)*1e6
        !    rho(i) = 0
        end do
        close(77)

        
        do i = 1, np
             beta(i) = 1e-1
        end do

!        beta(1) =19572.461697234903       
!        beta(2) =-2071789.1608516034        
!        beta(3) =26065893.188729271
!        beta(4) =-73302423.576737210        
!        beta(5) =50049752.723462105

         
         
 
        
        call odr_wrap_implicit(n,m, np, nq, x, y, beta, ux, uy, rho, stdev_beta, cov, info)

        write(*,*) 'beta', beta
        write(*,*) 'stdev_beta', stdev_beta
        write(*,*) 'relative error', stdev_beta/beta
        write(*,*) 'correlation beta', cov
        write(*,*) 'info', info



end program
