program fit_line_odr

      use real_precision
      use odrpack95
      
! fit straight line through data from file
        
        implicit none
        character*256 ::  my_file
        real(kind=r8), dimension (:,:), allocatable ::   x,y 
        real(kind=r8), dimension (:,:), allocatable ::   ux, uy 
        real(kind=r8), dimension (:), allocatable ::   rho

        integer ::     iargc,n

        integer ::  i, len, iostatus

        integer, parameter :: np = 2
        integer :: m, nq

        real(kind=r8) :: beta(np)
        real(kind=r8) :: stdev_beta(np)
        real(kind=r8) :: cov(np*(np-1)/2)

        integer :: info


        m = 2
        nq = 1

        if (iargc().lt.1)  stop './fit_area_odr filename'
        call getarg(1,my_file)

        len = index(my_file,' ') - 1

        open(unit=77, file=my_file(1:len), status='old')
        n = 0
        read(77, *, IOSTAT=iostatus) my_file
        do  while (iostatus == 0)
          n= n+1
          read(77, *, IOSTAT=iostatus) my_file
        end do

        if (n == 0 ) then
           stop 'Empty file'
        end if 
        

        write(*,*) n, m, nq, size(x)
        allocate(x(n, m))
        allocate(y(n, nq))
        allocate(ux(n,m))
        allocate(uy(n, nq))
        allocate(rho(n))

        rewind(unit = 77)
        do i = 1,n
            read(77, *) x(i,1), x(i,2), ux(i,1), ux(i,2), rho(i)
        end do
        close(77)

        
        do i = 1,n
            write(*,*)  x(i,:), ux(i,:)
        end do

        do i = 1, np
             beta(i) = 1e-1
        end do

 
        call odr_wrap_implicit_line(n,m, np, nq, x, y, beta, ux, uy, rho, stdev_beta, cov, info)

        write(*,*) 'beta', beta
        write(*,*) 'stdev_beta', stdev_beta
        write(*,*) 'relative error', stdev_beta/beta
        write(*,*) 'correlation beta', cov
        write(*,*) 'info', info



end program
