#include "dialog_about.h"

#include "controls.h"
#include "datatypes.h"
#include "indent-toolbox-common.h"

#include <gtk/gtk.h>


void show_about (GtkWidget *widget, Data *data)
{
    gtk_dialog_run (GTK_DIALOG (data->controls->maincontrols->dialog_about));
    gtk_widget_hide (GTK_WIDGET (data->controls->maincontrols->dialog_about));
}

void about_dialog_create(Data *data)
{
    MainControls *maincontrols;

/* #ifndef G_OS_WIN32 */
/*     GdkPixbuf *logo_pixbuf; */
/*     GError *error = NULL; */
/* #endif */
    const gchar *authors[] = {"Anna Charvátová Campbell",
			      "Radek Šlesinger",
			      "Petr Grolich",
			      "",
			      "ODR function fitting:",
			      "J. W. Zwolak, P. T. Boggs, L. T. Watson: Algorithm 869: ODRPACK95: A weighted orthogonal distance regression code with bound constraints. ACM Trans. Math. Softw. (2007)",
			      NULL};


    maincontrols = data->controls->maincontrols;

    maincontrols->dialog_about = gtk_about_dialog_new ();
    gtk_about_dialog_set_program_name (GTK_ABOUT_DIALOG(maincontrols->dialog_about), "Niget");
    gtk_about_dialog_set_comments (GTK_ABOUT_DIALOG(maincontrols->dialog_about), "NanoIndentation General Evaluation Tool");
    gtk_about_dialog_set_version (GTK_ABOUT_DIALOG(maincontrols->dialog_about), "0.3");
    gtk_about_dialog_set_copyright (GTK_ABOUT_DIALOG(maincontrols->dialog_about), "Anna Charvátová Campbell, Radek Šlesinger, Petr Grolich\nCzech Metrology Institute");
    gtk_about_dialog_set_license (GTK_ABOUT_DIALOG(maincontrols->dialog_about), "GNU General Public License, version 2");
#ifndef G_OS_WIN32
    /* temporarily deprecated, 'gtk_show_uri' and 'g_app_info_launch_default_for_uri' cannot find default web browser*/
    gtk_about_dialog_set_website (GTK_ABOUT_DIALOG(maincontrols->dialog_about), "http://nanometrologie.cz/niget");
#endif
    gtk_about_dialog_set_website_label (GTK_ABOUT_DIALOG(maincontrols->dialog_about), "http://nanometrologie.cz/niget");
    gtk_about_dialog_set_authors (GTK_ABOUT_DIALOG(maincontrols->dialog_about), authors);
    gtk_window_set_icon_name (GTK_WINDOW(maincontrols->dialog_about), GTK_STOCK_ABOUT);
    
/* #ifndef G_OS_WIN32 */
/*     logo_pixbuf = gdk_pixbuf_new_from_resource ("/resources/logo.jpg", &error); */
/*     gtk_about_dialog_set_logo (GTK_ABOUT_DIALOG(maincontrols->dialog_about), logo_pixbuf); */
/* #endif */
}
