#ifndef FILE_UTILS_H
#define FILE_UTILS_H

#include "datatypes.h"

typedef enum {
    READ_FILE_OK = 0,
    READ_FILE_COULD_NOT_OPEN,
    READ_FILE_NOT_ENOUGH_ENTRIES,
    READ_FILE_FORMAT_MISMATCH,
    READ_FILE_CONTAINS_NAN,
    READ_FILE_CONTAINS_INF
} FileReadStatus;

typedef enum {
    SAVE_FILE_OK = 0,
    SAVE_FILE_COULD_NOT_OPEN,
    SAVE_FILE_NO_DATA
} FileSaveStatus;

typedef enum {
	AREA_FILE_OK = 0,
	AREA_FILE_COULD_NOT_OPEN,
	AREA_FILE_NOT_ENOUGH_ENTRIES,
	AREA_FILE_FORMAT_MISMATCH,
	AREA_FILE_POLYNOM,
	AREA_FILE_TIP
}AreaFileReadStatus;

#define DATAFORMAT_HEADER_FORMAT "#NIGET %d %d %d %d"
#define DATAFORMAT_HEADER_FORMAT_NEWLINE "#NIGET %d %d %d %d\n"

gboolean file_contains_data(gchar *filename, enum DataFileFormat fileformat, FileReadStatus *filestatus);

FileReadStatus load_data_nogui(gchar *filename, enum DataFileFormat fileformat, FDdata *fddata, gboolean *splitok);

gboolean data_write_file(gchar *filename, Args *args, FileSaveStatus *filestatus);
gchar* create_log_filename_path(const gchar* fname);
gint get_number_lines(FILE *infile) ;
AreaFileReadStatus read_area_hysitron_file(const gchar *fnm, Area *area);
AreaFileReadStatus read_area_csm_file(const gchar *fnm, Area *area);
AreaFileReadStatus read_area_dat_file(const gchar *fnm, Area *area);
#endif
