#include "indent-toolbox-common.h"

#include <locale.h>

#define _USE_MATH_DEFINES
#include <math.h>

#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>

#include <libprocess/gwyprocess.h>
#include <libgwyddion/gwyddion.h>
#include <app/gwyapp.h>

/* can be used from math.h */
/*
#define A 12

double
sp_gamma(double z)
{
    const int a = A;
    static double c_space[A];
    static double *c = NULL;
    int k;
    double accm;

    if (c == NULL ) {
        double k1_factrl = 1.0; // (k - 1)!*(-1)^k with 0!==1
        c = c_space;
        c[0] = sqrt(2.0*M_PI);
        for(k = 1; k < a; k++) {
            c[k] = exp(a-k) * pow(a-k, k-0.5) / k1_factrl;
            k1_factrl *= -k;
        }
    }
    accm = c[0];
    for(k = 1; k < a; k++)
        accm += c[k] / (z + k);
    accm *= exp(-(z+a)) * pow(z+a, z+0.5); // Gamma(z+1) 
    return accm/z;
}
*/

/* opsane z Octavi verze */
gdouble
psi(gdouble z)
{
	gdouble h;

	h = 1e-9;
	
	if (z > 0 )
		return  (lgamma(z + h) - lgamma(z -h ))/(2*h);
	else if (z < 0 )
		return  (lgamma(1-z + h) - lgamma(1-z -h ))/(2*h) + M_PI/tan(M_PI*(1-z));
	else
		return  -1e30;

}

/*
=======================================

UNSORTED

=======================================

*/

GwyDataLine*
moving_average (GwyDataLine *x, gint nmove) //TODO prepsat hezceji, rychleji, obecnejsi vahy, doplnit okraje
{
	GwyDataLine *data_line;
	gint i,j, s,n;

	if (nmove == 1 || nmove > (x->res / 2)) { /* temporary fix to avoid out of mem access */
		data_line=gwy_data_line_duplicate(x);
	}
	else{
		s = (nmove -1 )/2; // nmove must be odd
		n = x->res; 
		data_line=gwy_data_line_new_alike(x,TRUE); /* LEAK */
		for (i = s; i< n-s; i++){
			for (j = -s; j <= s ; j++){
				data_line->data[i] += x->data[i+j]/nmove;
			}
		}

		for ( i = 0; i < s; i++){
			/*			for (j = MAX(-s,-i); j <= s ; j++){
						data_line->data[i] += x->data[i+j]/(nmove-s+i);
						}
						*/
			data_line->data[i] = x->data[i];
		}
		for (i = n-s; i < n; i++){
			/*			for (j = -s; j <MIN( s,n-i) ; j++){
						data_line->data[i] += x->data[i+j]/(nmove-s+n-1-i);
						}
						*/
			data_line->data[i] = x->data[i];
		}

	}
	return data_line;
}

GwyDataLine*
moving_average_rs (GwyDataLine *x, gint nmove) //TODO prepsat hezceji, rychleji, obecnejsi vahy, doplnit okraje
{
    GwyDataLine *data_line;
    gint i, j, l, u, w, s, n;
    printf("\n");

    if (nmove == 1)
	data_line = gwy_data_line_duplicate(x);
    else {
	s = (nmove - 1) / 2; // nmove must be odd
	n = x->res;
	data_line = gwy_data_line_new_alike(x,TRUE);

	for (i = 0; i < n; i++) {
	    l = MAX(0,   i-s);
	    u = MIN(n-1, i+s);
	    w = u - l + 1;
	    for (j = l; j <= u; j++)
		data_line->data[i] += x->data[j];
	    data_line->data[i] /= w;
	    printf("%g   \t%g\n",x->data[i],data_line->data[i]);
	}
    }
    
    return data_line;
}


void
range_to_indices(gdouble from, gdouble to, GwyDataLine *x, gboolean descending, gint *istart, gint *iend, gint *ndata)
{
	gint i=0;

	*ndata = 0;

	if (descending){
		while (i < x->res && x->data[i] > to)
			i++;
		*istart = i;

		while(i< x->res && x->data[i] > from)
			i++;
		*iend = i;
	}
	else{
		while(i< x->res && x->data[i] < from){
			i++;
		}
		*istart = i;
		while (i < x->res && x->data[i] < to){
//			printf("i %d res %d x %g to %g\n", i, x->res, x->data[i], to);
			i++;
		}
		if (i == x->res)
			i--;

		*iend = i;
	}
	*ndata = *iend - *istart;
}

void
range_to_indices_array(gdouble from, gdouble to, const gdouble *x, gint l, gboolean descending, gint *istart, gint *iend, gint *ndata)
{
    gint i;

    if (l > 0) {
	if (!descending) {
	    i = 0;
	    while (i < (l - 1) && x[i] < from)
		i++;
	    *istart = i;
	
	    i = l - 1;
	    while (i > *istart && x[i] > to)
		i--;
	    *iend = i;
	}
	else {
	    i = l - 1;
	    while (i > 0 && x[i] < from)
		i--;
	    *iend = i;

	    i = 0;
	    while (i < *iend && x[i] > to)
		i++;
	    *istart = i;
	}

	if ((*istart == *iend) && ((x[*istart] < from) || (x[*istart] > to))) {
	    *istart = -1;
	    *iend = -1;
	    *ndata = 0;
	}
	else    
	    *ndata = *iend - *istart + 1;
    }
    else { /* empty array */
	*istart = -1;
	*iend = -1;
	*ndata = 0;
    }
}

void
range_to_indices_dataline(gdouble from, gdouble to, GwyDataLine *x, gboolean descending, gint *istart, gint *iend, gint *ndata)
{
    range_to_indices_array(from, to, x->data, gwy_data_line_get_res(x), descending, istart, iend, ndata);
}

void
localize_decimal_points(gchar *str)
{
    gchar *p;
    struct lconv *locale;

    if (str) {
	locale = localeconv();
	if (locale->decimal_point) {
	    p = str;
	    while (*p) {
		if ((*p == '.') || (*p == ','))
		    *p = *(locale->decimal_point);
		p++;
	    }
	}
    }
}
