#ifndef INDENT_TOOLBOX_COMMON_H
#define INDENT_TOOLBOX_COMMON_H

#include <libprocess/gwyprocess.h>

#define NDER 3
#define NLOAD 2

/* temporary fix for MSVC */
#ifndef VERBOSE
#define VERBOSE FALSE
#endif

#ifndef SAVEMC
#define SAVEMC FALSE
#endif

#ifndef SAVEMC2
#define SAVEMC2 FALSE
#endif

#define N_MC 10000 // number of Monte Carlo iterations

#ifndef NOFORTRAN
enum {
    CONTACT=0,
    OP,
    OPODR,
    TANGENT,
    HERTZ,
    HERTZODR,
    SLOPES,
    DIFF,
    APOP,
    WORK,
    CREEP,
    RELAX,
    PPOP,
};
#else
enum {
    CONTACT=0,
    OP,
    TANGENT,
    HERTZ,
    DIFF,
    APOP,
    WORK,
    CREEP,
    RELAX,
    PPOP,
};
#endif

#define DEPTH "%.3f"
#define FORCE "%.3f"
#define HARD "%.2f"
#define MODUL "%.4f"
#define NUMBER "%.3f"
#define AREA  "%.0f"
#define SLOPE "%.5g"
#define EPWORK  "%.2f"
#define DELTA   "= σ<sub>F</sub><sup>2</sup>/σ<sub>h</sub><sup>2</sup> = %.03g"

//double sp_gamma(double z);
gdouble psi(double z);

void range_to_indices(gdouble from, gdouble to, GwyDataLine *x, gboolean descending, gint *istart, gint *iend, gint *ndata);
/* void graph_selected(GwyGraph* graph, Data *data); */

GwyDataLine* moving_average (GwyDataLine *x, gint n);

void range_to_indices_array(gdouble from, gdouble to, const gdouble *x, gint l, gboolean descending, gint *istart, gint *iend, gint *ndata);
void range_to_indices_dataline(gdouble from, gdouble to, GwyDataLine *x, gboolean descending, gint *istart, gint *iend, gint *ndata);

void localize_decimal_points(gchar *str);
#endif
