#!/usr/bin/python

import os, subprocess, time, re

execfnm="/home/campbell/indent-toolbox/indent-toolbox/build/niget-cmd"

ncpu=200
allowed_cpurange=range(100,600)
if (len(allowed_cpurange) < ncpu):
	ncpu=len(allowed_cpurange)

fin=open("settings.opodr.template")
fpy_content=fin.read()

def get_cpus(needed=1,blacklist=[], cheat=False):
    freecores=[]
    if cheat:
         return range(8,8+needed)
    with open("/ramfs/free_cores.txt") as f:
    	inf=f.readlines()
    	freecores=[x for x in map(int, inf[0].split()) if x not in blacklist]
    return freecores


def file_range_tuple(flist, lowlist, uplist):
	for f in flist:
		for low in lowlist:
			for up in uplist:
				yield f,low,up


def substitute_op_settings(frange):
	f,low,up = frange
	fnew_content=re.sub("LR", "%g" %low, fpy_content)
	fnew_content=re.sub("UR", "%g" %up, fnew_content)
	settname="settings.opodr_%(l)g_%(u)g" %{'l':low, 'u':up}
	with open(settname, "w") as fpynew:
			fpynew.write(fnew_content)

def run_tuple_cpu(frange, icpu):
	f,low,up = frange
	settname="settings.opodr_%(l)g_%(u)g" %{'l':low, 'u':up}
	cmd=["taskset", "-c", "%d" %icpu, execfnm, "-f", f, "-d", settname, "-U", "settings.unc"]
	print cmd
	#out=open("/dev/null", "w")
	out=open("out"+f, "w");
	proc = subprocess.Popen(cmd, stdout=out)
#	proc = subprocess.Popen(cmd)
	return proc
	
def check_output_files(frange):
	f,low,up = frange

	out=f+"__op_odr_range_%(l).2g_%(u).2g_%%.dat" %{'l':low, 'u':up}
	if not os.path.isfile(out):
		return False
	out=f+"__op_odr_unc_range_%(l).2g_%(u).2g_%%.dat" %{'l':low, 'u':up}
	if not os.path.isfile(out):
		return False
#	out=f+"__op_odr_mc1000_range_%(l).2g_%(u).2g_%%.dat" %{'l':low, 'u':up}
#	if not os.path.isfile(out):
#		return False

	return True



#lowlist=[20,30,40]
#uplist=[90,95,98]
lowlist=[20]
uplist=[98]

flist=[]
#only every 10th file
#for f  in os.listdir(os.getcwd()):
#        if f.endswith(".nig") and not f.startswith("auto"):
#	   ll=f.split("_")
#	   i=int(ll[1])
#	   if (i%10 ==0):
#	           flist.append(f)

#only files without ambiguities in contact (i.e. no A,B versions)
for f  in os.listdir(os.getcwd()):
        if f.endswith(".nig")  and not f.startswith("out"):
	   ll=f.split("_")
#	   try:
#		   i=int(ll[1])
           flist.append(f)
#	   except:
#		   pass


#all files
#for f  in os.listdir(os.getcwd()):
#        if f.endswith(".nig") and not f.startswith("auto"):
#	           flist.append(f)

print flist
forbidden_cpurange=[x for x in range(576) if x not in allowed_cpurange]
freecores=get_cpus(ncpu, forbidden_cpurange)
ncpu=min(ncpu, len(freecores))
allrange=file_range_tuple(flist, lowlist, uplist)

processes=[None] * ncpu

while True:
	alldone=True
	for i in range(ncpu):
		p=processes[i]
		if p==None or p.poll() !=None:
			try:
				while (1):
					next=allrange.next()
					f,low,up = next
					done=check_output_files(next)
					if (not done):
						break
					else:
						print 'done for', f, low, up
				print next
				substitute_op_settings(next)
				time.sleep(0.5)
				processes[i]=run_tuple_cpu(next, freecores[i])
				alldone=False
			except:
				processes[i]=None
		else:
			alldone=False
	if alldone:
		raise SystemExit
        time.sleep(5)
