#ifndef TOOL_OP_UNC_H
#define TOOL_OP_UNC_H

#include "datatypes.h"
#include "file-utils.h"
#include "instrument.h"

void op_propagate_uncertainties_calc (Args *args);
gboolean op_uncertainty_write_file(gchar *filename, Args *args, FileSaveStatus *filestatus);
void op_fit_shift_contact(OPdata *opdata, FDdata *fddata, Instdata *instdata, Area *area, gdouble *Sc, gdouble *Ec,gdouble *Hc,gint j);

gboolean op_mc_write_file(gchar *filename, Args *args, FileSaveStatus *filestatus);
void op_uncertainty_montecarlo_run_calc(Args *args);
void init_OPMCdata (OPMCdata *opmc, gint Nmc);
void destroy_OPMCdata (OPMCdata *opmc);

#define NPARAM 6  //hc, Aphc, Hit, Er, Eit, S
#define MAXBAD 5 //maximum percentage of nonsense results before warning is triggered

#define CONTACTMAX 3

#endif
