#include <gtk/gtk.h>
#include <app/file.h>

#include "indent-toolbox-common.h"
#include "gui-utils.h"
#include "tool_ppopins.h"

void ppopin_active(Data *data)
{
	printf("popin P active \n");
}

void 
ppopin_run(Data *data)
{
}

static void ppopin_write_file(gchar *filename, Args *args) 
{
	FILE *file;

	if (args->fddata.hload->res == 0 || args->fddata.Fload->res==0) {
	    show_error("No data.");
	    return;
	}

	file = fopen(filename, "w");
	if (!file) {
	    show_error("Could not save file.");
	    return;
	}

	fprintf(file, "#Popins found by method P \n");
	fclose(file); 

}
static void ppopin_save_data( Args *args)
{
	GtkWidget *dialog;
	gchar *filename;
	FDdata fddata;

	fddata=args->fddata;

	printf("export data \n");

	if (fddata.hload==NULL)
		printf("FD data NULL \n");
	else 
		printf("FD data %d \n", fddata.hload->res);
	
	dialog = gtk_file_chooser_dialog_new("Save File",
			NULL,
			GTK_FILE_CHOOSER_ACTION_SAVE,
			GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
			GTK_STOCK_SAVE, GTK_RESPONSE_OK,
			NULL);

	gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(dialog), gwy_app_get_current_directory());

	if ( gtk_dialog_run (GTK_DIALOG ( dialog)) == GTK_RESPONSE_OK)
	{
		filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		printf("filename %s \n", filename);
		if (gwy_app_file_confirm_overwrite(dialog))
			ppopin_write_file(filename, args);
		g_free(filename);
	}

	gtk_widget_destroy ( dialog);
}

GtkWidget *
tool_ppopins_create (Data *data)
{
	PpopinControls *ppopcontrols;
	GtkWidget *hbox_buttons;
	Args *args;

	args=data->args;
	ppopcontrols=data->controls->ppopcontrols;
	
	ppopcontrols->button_run = gtk_button_new_with_mnemonic(gwy_sgettext("verb|_Run"));
	gtk_button_set_image (GTK_BUTTON (ppopcontrols->button_run), gtk_image_new_from_stock (GTK_STOCK_MEDIA_PLAY, GTK_ICON_SIZE_BUTTON));
	g_signal_connect_swapped (ppopcontrols->button_run, "clicked", G_CALLBACK (ppopin_run), data);

	ppopcontrols->button_save = gtk_button_new_from_stock (GTK_STOCK_SAVE);
	g_signal_connect_swapped (ppopcontrols->button_save, "clicked", G_CALLBACK (ppopin_save_data), args);

	hbox_buttons = gtk_hbox_new (FALSE, 10);

	gtk_box_pack_start (GTK_BOX (hbox_buttons), ppopcontrols->button_run, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX (hbox_buttons), ppopcontrols->button_save, FALSE, FALSE, 0);
	    
	ppopcontrols->ppop_gui = gtk_vbox_new(FALSE,10);
	gtk_box_pack_start (GTK_BOX (ppopcontrols->ppop_gui), hbox_buttons, FALSE, FALSE, 0);

	gtk_widget_show(ppopcontrols->ppop_gui);
    printf("Pop-ins Petr hotovo\n");
    return ppopcontrols->ppop_gui;
}
