#ifndef TOOL_TANGENT_UNC_H
#define TOOL_TANGENT_UNC_H

#include "datatypes.h"
#include "file-utils.h"
#include "instrument.h"

#define CONTACTMAX 3
#define NPARAM 6  // hc, Aphc, Hit, Er, Eit,S
#define MAXBAD 5 //maximum percentage of nonsense results before warning is triggered

void tangent_propagate_uncertainties_calc (Args *args);
gboolean tangent_uncertainty_write_file(gchar *filename, Args *args, FileSaveStatus *filestatus);
void tangent_fit_shift_contact(Tangentdata *tgdata, FDdata *fddata, Instdata *inst, Area *area, gdouble *Sc,gdouble *Ec,gdouble *Hc,gint j);

gboolean tangent_mc_write_file(gchar *filename, Args *args, FileSaveStatus *filestatus) ;
void tangent_uncertainty_montecarlo_run_calc(Args *args);
void init_TangentMCdata (TangentMCdata *tgmc, gint Nmc);
void destroy_TangentMCdata (TangentMCdata *tgmc);

#endif
