#ifndef NOFORTRAN

#ifndef TOOL_SLOPES_UNC_H
#define TOOL_SLOPES_UNC_H

#include "datatypes.h"
#include "file-utils.h"

#define NPARAM 8  //  Sload, Sunload,Hit, Er, Eit, Aphc, m, n
#define MAXBAD 5 //maximum percentage of nonsense results before warning is triggered

#define CONTACTMAX 3
#define MC_WHEN_WARN 5e2

void slopes_propagate_uncertainties_calc (Args *args);
gboolean slopes_uncertainty_write_file(gchar *filename, Args *args, FileSaveStatus *filestatus);
void slopes_fit_shift_contact(Slopesdata *sldata, FDdata *fddata, Instdata *instdata, Area *area, gdouble *Ec, gdouble *Hc, gdouble *Ac, gint j);

gboolean slopes_mc_write_file(gchar *filename, Args *args, FileSaveStatus *filestatus);
void slopes_uncertainty_montecarlo_run_calc( Args *args);
void init_SlopesMCdata (SlopesMCdata *slopesmc, gint Nmc);
void destroy_SlopesMCdata (SlopesMCdata *slopesmc);

#endif

#endif
